#ifndef _BF_VDSP_
#define _BF_VDSP_
#ifdef __ECC__
#error This header file is for gcc.
#endif /* __ECC__ */

#include <sys/exception.h>

typedef __attribute__((interrupt_handler)) void (*ex_handler_fn_gcc)(void);
#define DECL_INT_HANDLER(handler) __attribute__((interrupt_handler)) void handler(void)

/* 荞݃nho^ */
static void s_bfin_register_handler(interrupt_kind kind, ex_handler_fn_gcc fn)
{
    uint32_t l_mask;

    if((ik_emulation > kind) || (kind > ik_ivg15)) return;

    *((ex_handler_fn_gcc*)&(((uint32_t*)EVT0)[(int32_t)kind])) = fn;
    l_mask  = cli();
    l_mask |= 1u << (int32_t)kind;
    sti(l_mask);
}

#endif /* _BF_VDSP_ */
