/*
 * TUNA-CANp31ohOtBbNCRCU
 *
 * Copyright 2013-2014 q^
 *
 * yӎz
 * @cEcړI킸{\tgEFA𖳏ŗp邱Ƃł܂B
 * @̃\tgEFA͖ۏ؂łBg̐ӔCɂĂpB
 *
 */

#include <cdefBF592-A.h>
#include <builtins.h>
#include <stdint.h>
#include <string.h>
#ifdef __ECC__
#include "bf_vdsp.h"
#else /* __ECC__ */
#include "bf_gcc.h"
#endif /* __ECC__ */

/*
#define BF_START_CYCLE_COUNT( _START_COUNT ) \
     do { \
          asm volatile ("CLI R0;       \n"  \
                        "R2 = CYCLES;  \n"  \
                        "R1 = CYCLES2; \n"  \
                        "STI R0;       \n"  \
                        "[%0]   = R2;  \n"  \
                        "[%0+4] = R1;  \n"  \
                        : : "a"(&(_START_COUNT)) \
                        : "R0", "R1", "R2" ); \
     } while (0)

#define BF_STOP_CYCLE_COUNT( _CURR_COUNT, _START_COUNT ) \
     do { \
       BF_START_CYCLE_COUNT(_CURR_COUNT); \
       (_CURR_COUNT) = (_CURR_COUNT) - (_START_COUNT); \
       (_CURR_COUNT) -= 8; \
     } while (0)
*/

/* VXeNbN(99MHz) */
#define SCLOCK_HZ       (99000000)

#define TWI_COUNT(x) (DCNT & ((x) << 6))
/* TWIp߂l */
#define NO_ERROR        (0)
#define TWI_ERROR_NAK   (-1)
/* s_twi_master_writerstartp` */
#define TWI_STOP        (0)
#define TWI_RSTART      (1)

/* SGTL5000I2CfoCXAhX */
#define TWI_CODEC_DEVICE_ADDR   (0x0A)

/* 1`l1̃TvTCY */
#define NUM_SAMPLES     (128)
/* `l(XeI) */
#define NUM_CHANNEL     (2)
/* obt@O(_uobt@) */
#define NUM_BUFFERS     (2)

/* {[[g(115200bps) */
#define UART0_BAUDRATE  (115200)
/* UART0_DLL/UART0_DLH̐ݒl */
#define UART0_DIVISOR   (SCLOCK_HZ/16/UART0_BAUDRATE)

/* TvO[g */
#define SAMPLEING_RATE  (48000)
/* oh */
#define NUM_BANDS       (31)

/* ꕔ̌Œ菬_` */
#define Q8_24_0_5       (8388608)       /* Q8.24 0.5 */
#define Q8_24_1_0       (16777216)      /* Q8.24 1.0 */
#define Q8_24_2_0       (33554432)      /* Q8.24 2.0 */
#define Q8_24_4_0       (67108864)      /* Q8.24 4.0 */

/* Œ菬_m̏Z */
#pragma always_inline
inline static int32_t mult_fr8_24x24(int32_t _a, int32_t _b)
{
    int32_t l_rv;
    asm(
        "A1 = %1.L * %2.L (FU);"
        "A1 = A1 >> 16;"
        "A0 = %1.H * %2.H, A1 += %1.H * %2.L (M);"
        "A1 += %2.H * %1.L (M);"
        "A1 = A1 >>> 16 - %3;"
        "A0 = A0 << %3 - 1;"
        "%0 = (A0 += A1);"
        : "=d"(l_rv) : "d"(_a), "d"(_b), "n"(32-24) : "A0", "A1");
    return l_rv;
}

#ifndef __ECC__

/* LZ֐Visual DSP++ł͒`ς݂Ȃ̂ŁAgcc̏ꍇ̂ݒ` */

/* ZiOa΍pj */
#pragma always_inline
inline static int32_t add_fr1x32(int32_t _a, int32_t _b)
{
    int32_t l_rv;
    asm("%0 = %1 + %2(S);" : "=d"(l_rv) : "d"(_a), "d"(_b));
    return l_rv;
}

/* ZiOa΍pj */
#pragma always_inline
inline static int32_t sub_fr1x32(int32_t _a, int32_t _b)
{
    int32_t l_rv;
    asm("%0 = %1 - %2(S);" : "=d"(l_rv) : "d"(_a), "d"(_b));
    return l_rv;
}

#endif /* __ECC__ */

/* UARTM荞݂̃vg^Cv錾 */
DECL_INT_HANDLER(s_uart_rx_isr);
/* SPORT RX DMA荞݂̃vg^Cv錾 */
DECL_INT_HANDLER(s_sport_rx_isr);
/* GP^C}0荞݂̃vg^Cv錾 */
DECL_INT_HANDLER(s_gptimer_isr);

/* I[fBIp֐ */
static void s_audio_process(const int32_t* p_left_rxbuf, const int32_t* p_right_rxbuf, int32_t* p_left_txbuf, int32_t* p_right_txbuf);

/* TWI(I2C)p֐ */
static void s_twi_init(void);
/* TWI(I2C)f[^Mp֐ */
static int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt);

/* SPORTMobt@(_uobt@,2`l) */
static int32_t sf_sport_rxbuf[NUM_CHANNEL][NUM_BUFFERS][NUM_SAMPLES];
/* SPORTMobt@(_uobt@,2`l) */
static int32_t sf_sport_txbuf[NUM_CHANNEL][NUM_BUFFERS][NUM_SAMPLES];
/* DMAǂ̃obt@gpĂ邩 */
static volatile int32_t sf_sport_use_bufidx;

/* DMApfBXNv^ */
struct dma_large_desc_t
{
    uint32_t next_addr;
    uint32_t addr;
    uint16_t cfg;
    uint16_t xcnt;
    int16_t  xmod;
    uint16_t ycnt;
    int16_t  ymod;
};

/* DMAfBXNv^` */
static struct dma_large_desc_t sf_sport_rxdma_desc[NUM_BUFFERS];
static struct dma_large_desc_t sf_sport_txdma_desc[NUM_BUFFERS];

/* f[^]tO */
static volatile int32_t sf_data_incoming;

/* CRCUptB^p[^(ExcelŌvZ萔 filter.cQ) */
extern const int32_t e_tan_theta0[NUM_BANDS];
extern const int32_t e_cos_theta0[NUM_BANDS];
extern const int32_t e_mu_1[256];
extern const int32_t e_beta_mu[256];

/* CRCUp[N */
typedef struct
{
    int32_t alpha;
    int32_t beta;
    int32_t gamma;
    int32_t mu_1;
    int32_t x[2];
    int32_t u[2];
} ge_filter;
static ge_filter ge_filter_work[2][NUM_BANDS];

typedef struct
{
    uint8_t updated;
    uint8_t value;
} slider_volume;

static slider_volume sv_work[31];

/* SGTL5000 TWIf[^ */
static const uint8_t sf_audio_init_data1[] =
{
    // Shutdown
    0x00, 0x02, 0x00, 0x00, // CHIP_DIG Power     0000-0000 0000-0000
    0x00, 0x04, 0x00, 0x08, // CHIP_CLK_CTRL      0000-0000 0000-1000
    0x00, 0x26, 0x00, 0x00, // CHIP_LINREG_CTRL   0000-0000 0000-0000 VDDD = 1.6V
    0x00, 0x30, 0x72, 0x00, // CHIP_ANA_POWER     0111-0010 0000-0000

    // Set up registers
    0x00, 0x06, 0x00, 0x80, // CHIP_I2S_CTRL      0000-0000 1000-0000
    0x00, 0x0A, 0x00, 0x10, // CHIP_SSS_CTRL      0000-0000 0001-0000
    0x00, 0x0E, 0x00, 0x00, // CHIP_ADCDAC_CTRL   0000-0000 0000-0000
    0x00, 0x10, 0x3C, 0x3C, // CHIP_DAC_VOL
    0x00, 0x14, 0x01, 0x55, // CHIP_PAD_STRENGTH  0000-0001 0101-0101
    0x00, 0x20, 0x02, 0x00, // CHIP_ANA_ADC_CTRL  0000-0010 0000-0000
    0x00, 0x22, 0x00, 0x00, // CHIP_ANA_HP_CTRL
    0x00, 0x24, 0x00, 0x26, // CHIP_ANA_CTRL      0000-0000 0010-0110
    0x00, 0x28, 0x00, 0x40, // CHIP_REF_CTRL      0000-0000 0100-0000 VAG_VAL = 0.9V
    0x00, 0x2A, 0x00, 0x00, // CHIP_MIC_CTRL      0000-0000 0000-0000
    0x00, 0x2C, 0x03, 0x22, // CHIP_LINE_OUT_CTRL 0000-0011 0010-0010 LO_VAGCNTRL = 1.65V
    0x00, 0x2E, 0x06, 0x06, // CHIP_LINE_OUT_VOL  0000-0110 0000-0110
    0x00, 0x34, 0x00, 0x00, // CHIP_CLK_TOP_CTRL  0000-0000 0000-0000
    0x00, 0x38, 0x01, 0xC0, // CHIP_ANA_TEST1     0000-0001 1100-0000
    0x01, 0x00, 0x00, 0x00, // DAP_CONTROL        0000-0000 0000-0000

    // Setup PLL
    0x00, 0x32, 0x83, 0x12, // CHIP_PLL_CTRL      1000-0011 0001-0010(16/786)
    // Power up analog modules (PLL/VGA/REF)
    0x00, 0x30, 0x47, 0x60, // CHIP_ANA_POWER     0100-0111 0110-0000
};

static const uint8_t sf_audio_init_data2[] =
{
    // Power up analog modules (ALL)
//  0x00, 0x30, 0x47, 0xFF, // CHIP_ANA_POWER     0100-0111 1111-1111
    0x00, 0x30, 0x47, 0xFA, // CHIP_ANA_POWER     0100-0111 1111-1010
    // Power up digital modules
    0x00, 0x02, 0x00, 0x63, // CHIP_DIG Power     0000-0000 0110-0011
    0x00, 0x04, 0x00, 0x0B, // CHIP_CLK_CTRL      0000-0000 0000-1011
};

/* 1msPʃJE^ */
static uint32_t sf_1ms_counter;


static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
    *pSIC_IWR = IWR_ENABLE(0);              /* PLL̂IWR */
    *pPLL_DIV = div_val;
    *pPLL_CTL = (mul_val) << 9;
    asm("cli r0; csync; idle; sti r0;": : :"R0");
    *pSIC_IWR = IWR_ENABLE_ALL;
}

/* w肳ꂽ}CNbҋ@ */
static void s_us_delay(uint32_t us)
{
    uint32_t l_start;
    uint32_t l_now;
    int32_t l_stop = us * (int32_t)(1000 / 2.5252525);  /* 1 cycle = 2.525..ns */

    asm("%0 = CYCLES;" : "=d"(l_start));
    while(1)
    {
        asm volatile("%0 = CYCLES;" : "=d"(l_now));
        if((l_now - l_start) >= l_stop)
            break;
    }
}

static void s_codec_init(void)
{
    uint32_t l_lc;

    /* CODEC҂(100ms) */
    s_us_delay(100000);

    /* SGTL5000 */
    for(l_lc = 0; l_lc < sizeof(sf_audio_init_data1); l_lc += 4)
    {
        /* SGTL5000WX^ݒ */
        s_twi_master_write(TWI_CODEC_DEVICE_ADDR, TWI_STOP, &sf_audio_init_data1[l_lc], 4);
        s_us_delay(1000); /* 莞ԑҋ@ */
    }
    /* PLL҂ */
    s_us_delay(100000);
    for(l_lc = 0; l_lc < sizeof(sf_audio_init_data2); l_lc += 4)
    {
        /* SGTL5000WX^ݒ */
        s_twi_master_write(TWI_CODEC_DEVICE_ADDR, TWI_STOP, &sf_audio_init_data2[l_lc], 4);
        s_us_delay(1000); /* 莞ԑҋ@ */
    }
}
void s_uart_init(void)
{
    /* UARTCl[u */
    *pUART0_GCTL = 1;

    /* UART̐ݒ */
    *pUART0_LCR |= DLAB;
    *pUART0_DLL = UART0_DIVISOR & 0xFF;
    *pUART0_DLH = UART0_DIVISOR >> 8;
    *pUART0_LCR &= ~DLAB;

    /* UART[hݒ peB 8bit 1Xgbvrbg */
    *pUART0_LCR = WLS(8);

    /* UART݋֎~ */
    *pUART0_IER = 0;

    /* PF11/PF12sUARTɊU */
    *pPORTF_MUX &= ~(PF11 | PF12);  /* PF11,PF120ɂ */
    *pPORTF_FER |= PF11 | PF12;     /* PF11,PF12UART0ɊU */

    /* 荞݃nhIVG10ɓo^ */
    s_bfin_register_handler(ik_ivg10, s_uart_rx_isr);
    /* UARTM݂ */
    *pUART0_IER = ERBFI;
    *pSIC_IMASK |= IRQ_DMA7;    /* DMA7 = UART RX */
}

void s_uart_putc(char ch)
{
    /* UART0 LSRTHRE1ɂȂ܂ő҂B1ȂΑMWX^ */
    while(0 == (*pUART0_LSR & THRE)) ssync();
    *pUART0_THR = ch;   /* ꕶM */
    ssync();
}

void s_uart_print(const char *p_buf)
{
    int l_lc;
    int l_len = strlen(p_buf);
    
    for(l_lc = 0; l_lc < l_len; l_lc++)
    {
        s_uart_putc(p_buf[l_lc]);   /* ꕶM */
    }
}

static void s_gefileter_update(int32_t band_idx, uint8_t pot_val)
{
    int32_t l_beta, l_beta_n, l_beta_d;

    /* ̕qvZ */
    l_beta_n = sub_fr1x32(Q8_24_1_0, mult_fr8_24x24(e_beta_mu[pot_val], e_tan_theta0[band_idx]));
    /* ̕vZ */
    l_beta_d = add_fr1x32(Q8_24_1_0, mult_fr8_24x24(e_beta_mu[pot_val], e_tan_theta0[band_idx]));
    /* vZ */
    l_beta = ((((long long)l_beta_n) << 24) / l_beta_d);
    l_beta /= 2;
    ge_filter_work[0][band_idx].beta  = l_beta;
    /* vZ */
    ge_filter_work[0][band_idx].alpha = sub_fr1x32(Q8_24_0_5, l_beta) / 2;
    /* vZ */
    ge_filter_work[0][band_idx].gamma = mult_fr8_24x24(add_fr1x32(Q8_24_0_5, l_beta), e_cos_theta0[band_idx]);
    /* {[ADCl-1擾 */
    ge_filter_work[0][band_idx].mu_1  = e_mu_1[pot_val];

    ge_filter_work[1][band_idx].beta  = ge_filter_work[0][band_idx].beta;
    ge_filter_work[1][band_idx].alpha = ge_filter_work[0][band_idx].alpha;
    ge_filter_work[1][band_idx].gamma = ge_filter_work[0][band_idx].gamma;
    ge_filter_work[1][band_idx].mu_1  = ge_filter_work[0][band_idx].mu_1;
}

static void s_filter_init(void)
{
    int32_t l_lc;
    int32_t l_beta, l_beta_n, l_beta_d;
 
    /* tB^p[N */   
    memset(sv_work, 0, sizeof(sv_work));
    /* POT̒l𒆊(0dB)ɐݒ */   
    for(l_lc = 0; l_lc < NUM_BANDS; l_lc++)
    {
        sv_work[l_lc].value = 128;
    }

    memset(ge_filter_work, 0, sizeof(ge_filter_work));

    for(l_lc = 0; l_lc < NUM_BANDS; l_lc++)
    {
        s_gefileter_update(l_lc, sv_work[l_lc].value);
    }
}

int main(void)
{
    uint32_t l_lc;
    int32_t  l_dmabuf_idx;

    /* VR_CTLݒ */
    /* EXTCLK_OE = 1, EXTCLK_SEL = 0 */
    *pVR_CTL = EXTCLK_OE | HIBERNATEB;

    /* PLLݒ */
    /* CCLK 12Mhz * 33 = 396MHz */
    /* SCLK CCLK / 4   =  99MHz */
    s_bfin_clk_pll_set(33, 4);

    /* obt@NA */
    memset(sf_sport_rxbuf, 0 , sizeof(sf_sport_rxbuf));
    memset(sf_sport_txbuf, 0 , sizeof(sf_sport_txbuf));
    sf_sport_use_bufidx = 0;
    sf_data_incoming = 0;
    sf_1ms_counter = 0;

    /* tB^ */
    s_filter_init();

    /* |[g̐ݒ(SW) */
    *pPORTF_FER    &= ~PF0;
    *pPORTFIO_DIR  &= ~PF0;
    *pPORTFIO_INEN |=  PF0;
    
    /* |[g̐ݒ(LED) */
    *pPORTF_FER    &= ~PF4;
    *pPORTFIO_DIR  |=  PF4;
    *pPORTFIO_INEN &= ~PF4;
    *pPORTFIO_CLEAR =  PF4;
    
    /* |[g̐ݒ(SPORT1) */
    *pPORTF_MUX &= ~(PF1 | PF2 | PF3 | PF5 | PF6 | PF7); 
    *pPORTF_FER |= PF1 | PF2 | PF3 | PF5 | PF6 | PF7;
    
    /* UART */
    s_uart_init();

#if 0 /* tB^֐TCNp */
    uint64_t start_cnt, cycle_cnt;
    char text[16];
    BF_START_CYCLE_COUNT(start_cnt);
    s_audio_process(
        sf_sport_rxbuf[0][0], sf_sport_rxbuf[1][0],
        sf_sport_txbuf[0][0], sf_sport_txbuf[1][0]);
    BF_STOP_CYCLE_COUNT(cycle_cnt, start_cnt);

    sprintf(text, "%lld\r\n", cycle_cnt);
    s_uart_print(text);
    while(1) ssync();
#endif

    /*
     * PG13(CTRL_MODE)o̓sɐݒ肷B
     */
    *pPORTGIO_CLEAR = PG13;
    *pPORTGIO_DIR  |= PG13;

    /* TWI */
    s_twi_init();
    /* SGTL5000 */
    s_codec_init();
    
    /* GP^C}0̐ݒ */
    /* 1msPʂɊ荞݂悤ɐݒ */
    *pTIMER0_CONFIG = OUT_DIS | IRQ_ENA | PERIOD_CNT | PWM_OUT;
    *pTIMER0_PERIOD = SCLOCK_HZ / 1000;
    *pTIMER0_WIDTH = 1;
    *pTIMER_ENABLE = TIMEN0;
    /* 荞݃nhIVG11ɓo^ */
    s_bfin_register_handler(ik_ivg11, s_gptimer_isr);
    *pSIC_IMASK |= IRQ_TIMER0;

    /* SPORT RX̐ݒ */
    /* ONbNAOSYNCAMSB First */
    /* 24rbgf[^A XeI */
    *pSPORT1_RCR1 = RFSR | RCKFE;
    *pSPORT1_RCR2 = SLEN(31) | RSFSE;
    /* SPORT TX̐ݒ */
    /* ONbNAOSYNCAMSB First */
    /* 24rbgf[^A XeI */
    *pSPORT1_TCR1 = TFSR | TCKFE;
    *pSPORT1_TCR2 = SLEN(31) | TSFSE;

    /* DMA3(SPORT1 RX)̐ݒ */
    sf_sport_rxdma_desc[0].next_addr = (uint32_t)&sf_sport_rxdma_desc[1];
    sf_sport_rxdma_desc[0].addr      = (uint32_t)&sf_sport_rxbuf[0][0][0];
    sf_sport_rxdma_desc[0].cfg       = FLOW_LARGE | NDSIZE_9 | DI_EN | DMA2D | WDSIZE_32 | WNR | DMAEN;
    sf_sport_rxdma_desc[0].xcnt      = 2;
    sf_sport_rxdma_desc[0].xmod      = (int16_t)sizeof(int32_t) * NUM_SAMPLES * NUM_BUFFERS; // = sf_sport_rxbuf[1][0][0]
    sf_sport_rxdma_desc[0].ycnt      = NUM_SAMPLES;
    sf_sport_rxdma_desc[0].ymod      = ((int16_t)sizeof(int32_t) * -NUM_SAMPLES * NUM_BUFFERS) + (int16_t)sizeof(int32_t);

    sf_sport_rxdma_desc[1].next_addr = (uint32_t)&sf_sport_rxdma_desc[0];
    sf_sport_rxdma_desc[1].addr      = (uint32_t)&sf_sport_rxbuf[0][1][0];
    sf_sport_rxdma_desc[1].cfg       = FLOW_LARGE | NDSIZE_9 | DI_EN | DMA2D | WDSIZE_32 | WNR | DMAEN;
    sf_sport_rxdma_desc[1].xcnt      = 2;
    sf_sport_rxdma_desc[1].xmod      = (int16_t)sizeof(int32_t) * NUM_SAMPLES * NUM_BUFFERS; // = sf_sport_rxbuf[1][1][0]
    sf_sport_rxdma_desc[1].ycnt      = NUM_SAMPLES;
    sf_sport_rxdma_desc[1].ymod      = ((int16_t)sizeof(int32_t) * -NUM_SAMPLES * NUM_BUFFERS) + (int16_t)sizeof(int32_t);

    *pDMA3_PERIPHERAL_MAP = 0x3000;
    *pDMA3_NEXT_DESC_PTR = &sf_sport_rxdma_desc[0];
    *pDMA3_CONFIG = FLOW_LARGE | NDSIZE_9 | WNR;
    *pDMA3_X_COUNT = 0;
    *pDMA3_IRQ_STATUS = DMA_DONE | DMA_ERR;

    /* DMA4(SPORT1 TX)̐ݒ */
    sf_sport_txdma_desc[0].next_addr = (uint32_t)&sf_sport_txdma_desc[1];
    sf_sport_txdma_desc[0].addr      = (uint32_t)&sf_sport_txbuf[0][0][0];
    sf_sport_txdma_desc[0].cfg       = FLOW_LARGE | NDSIZE_9 | DI_EN | DMA2D | WDSIZE_32 | DMAEN;
    sf_sport_txdma_desc[0].xcnt      = 2;
    sf_sport_txdma_desc[0].xmod      = (int16_t)sizeof(int32_t) * NUM_SAMPLES * NUM_BUFFERS; // = sf_sport_rxbuf[1][0][0]
    sf_sport_txdma_desc[0].ycnt      = NUM_SAMPLES;
    sf_sport_txdma_desc[0].ymod      = ((int16_t)sizeof(int32_t) * -NUM_SAMPLES * NUM_BUFFERS) + (int16_t)sizeof(int32_t);

    sf_sport_txdma_desc[1].next_addr = (uint32_t)&sf_sport_txdma_desc[0];
    sf_sport_txdma_desc[1].addr      = (uint32_t)&sf_sport_txbuf[0][1][0];
    sf_sport_txdma_desc[1].cfg       = FLOW_LARGE | NDSIZE_9 | DI_EN | DMA2D | WDSIZE_32 | DMAEN;
    sf_sport_txdma_desc[1].xcnt      = 2;
    sf_sport_txdma_desc[1].xmod      = (int16_t)sizeof(int32_t) * NUM_SAMPLES * NUM_BUFFERS; // = sf_sport_txbuf[1][1][0]
    sf_sport_txdma_desc[1].ycnt      = NUM_SAMPLES;
    sf_sport_txdma_desc[1].ymod      = ((int16_t)sizeof(int32_t) * -NUM_SAMPLES * NUM_BUFFERS) + (int16_t)sizeof(int32_t);

    *pDMA4_PERIPHERAL_MAP = 0x4000;
    *pDMA4_NEXT_DESC_PTR = &sf_sport_txdma_desc[0];
    *pDMA4_CONFIG = FLOW_LARGE | NDSIZE_9;
    *pDMA4_X_COUNT = 0;
    *pDMA4_IRQ_STATUS = DMA_DONE | DMA_ERR;
    ssync();

    /* 荞݃nhIVG9ɓo^ */
    s_bfin_register_handler(ik_ivg9, s_sport_rx_isr);
    *pSIC_IMASK |= IRQ_DMA3;

    /* DMAL */
    *pDMA3_IRQ_STATUS = DMA_DONE;
    *pDMA3_CONFIG |= DMAEN;
    *pDMA4_CONFIG |= DMAEN;
    /* SPORT1L */
    *pSPORT1_TCR1 |= TSPEN;
    *pSPORT1_RCR1 |= RSPEN;
    ssync();

    while(1)
    {
        idle();
        if(0 != sf_data_incoming)
        {
            /* tONA */
            sf_data_incoming = 0;
            /* gpĂ悢obt@擾 */
            l_dmabuf_idx = sf_sport_use_bufidx ^ 1;
            s_audio_process(
                sf_sport_rxbuf[0][l_dmabuf_idx], sf_sport_rxbuf[1][l_dmabuf_idx],
                sf_sport_txbuf[0][l_dmabuf_idx], sf_sport_txbuf[1][l_dmabuf_idx]);
            /* XVĂPOT̒l΃tB^Đݒ */
            for(l_lc = 0; l_lc < NUM_BANDS; l_lc++)
            {
                if(sv_work[l_lc].updated)
                {
                    sv_work[l_lc].updated = 0;
                    s_gefileter_update(l_lc, sv_work[l_lc].value);
                    break;
                }
            }
        }
    }
}

void s_audio_process(const int32_t* p_left_rxbuf, const int32_t* p_right_rxbuf, int32_t* p_left_txbuf, int32_t* p_right_txbuf)
{
    int32_t l_idx;
    int32_t l_band;
    int32_t l_u, l_x, l_y;

    /* L`l */
    for(l_idx = 0; l_idx < NUM_SAMPLES; l_idx++)
    {
        l_x = p_left_rxbuf[l_idx] >> 2; /* ͂-12dB */
        /* oh[v */
        for(l_band = 0; l_band < NUM_BANDS; l_band++)
        {
            /* u(n)vZ */
            l_u = 2 * (
                    mult_fr8_24x24(ge_filter_work[0][l_band].alpha, sub_fr1x32(l_x, ge_filter_work[0][l_band].x[1])) +
                    mult_fr8_24x24(ge_filter_work[0][l_band].gamma, ge_filter_work[0][l_band].u[0]) -
                    mult_fr8_24x24(ge_filter_work[0][l_band].beta,  ge_filter_work[0][l_band].u[1]));
            ge_filter_work[0][l_band].u[1] = ge_filter_work[0][l_band].u[0];
            ge_filter_work[0][l_band].u[0] = l_u;
            ge_filter_work[0][l_band].x[1] = ge_filter_work[0][l_band].x[0];
            ge_filter_work[0][l_band].x[0] = l_x;

            /* y(n)vZ */
            l_x = add_fr1x32(l_x, mult_fr8_24x24(ge_filter_work[0][l_band].mu_1, l_u));
        }
        /* o̓obt@Ɋi[ */
        p_left_txbuf[l_idx] = l_x;
    }
    /* R`l */
    for(l_idx = 0; l_idx < NUM_SAMPLES; l_idx++)
    {
        l_x = p_right_rxbuf[l_idx] >> 2; /* ͂-12dB */
        /* oh[v */
        for(l_band = 0; l_band < NUM_BANDS; l_band++)
        {
            /* u(n)vZ */
            l_u = 2 * (
                    mult_fr8_24x24(ge_filter_work[1][l_band].alpha, sub_fr1x32(l_x, ge_filter_work[1][l_band].x[1])) +
                    mult_fr8_24x24(ge_filter_work[1][l_band].gamma, ge_filter_work[1][l_band].u[0]) -
                    mult_fr8_24x24(ge_filter_work[1][l_band].beta,  ge_filter_work[1][l_band].u[1]));
            ge_filter_work[1][l_band].u[1] = ge_filter_work[1][l_band].u[0];
            ge_filter_work[1][l_band].u[0] = l_u;
            ge_filter_work[1][l_band].x[1] = ge_filter_work[1][l_band].x[0];
            ge_filter_work[1][l_band].x[0] = l_x;

            /* y(n)vZ */
            l_x = add_fr1x32(l_x, mult_fr8_24x24(ge_filter_work[1][l_band].mu_1, l_u));
        }
        p_right_txbuf[l_idx] = l_x;
    }
}

/* SPORT RX DMA荞݃nh */
DECL_INT_HANDLER(s_sport_rx_isr)
{
    *pDMA3_IRQ_STATUS = DMA_DONE;
    ssync();
    /* I[fBIR[fbNf[^ */
    sf_data_incoming = 1;
    /* DMAgpobt@ύX */
    sf_sport_use_bufidx = (sf_sport_use_bufidx ^ 1) & 1;
}

DECL_INT_HANDLER(s_uart_rx_isr)
{
    static int32_t sf_uart_recv_cnt = 0;
    static uint8_t sf_uart_buf;
    uint8_t l_recv;
    uint8_t l_ch;
    
    /* Mf[^ */
    l_recv = *pUART0_RBR;
    ssync();

    switch(sf_uart_recv_cnt)
    {
    case 0:
        if((l_recv & 0x80u) != 0u)
        {
            /* X^[grbgo */
            sf_uart_buf = l_recv;
            sf_uart_recv_cnt++;
        }
        break;
    case 1:
        /* fR[hsAPOTf[^XV */
        l_ch   = (sf_uart_buf & 0x7Eu) >> 1;
        l_recv = (((uint16_t)sf_uart_buf & 0x01u) << 7) | ((uint16_t)l_recv & 0x7Fu);
        if(l_ch < 31)
        {
            /* POT`l͈͗L */
            sv_work[l_ch].updated = 1;
            sv_work[l_ch].value = l_recv;
        }
        sf_uart_recv_cnt = 0;
        break;
    }
}


/* TWI(I2C) */
void s_twi_init(void)
{
    *pTWI_CONTROL = 0;
    ssync();
    *pTWI_CONTROL = TWI_ENA | 10U;
    *pTWI_CLKDIV  = CLKHI(8) | CLKLOW(17);
    *pTWI_INT_MASK = RCVSERV | XMTSERV | MERR | MCOMP;
    *pTWI_INT_STAT = *pTWI_INT_STAT;
    *pTWI_FIFO_CTL = XMTFLUSH | RCVFLUSH;
    ssync();
}

int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt)
{
    int32_t l_idx;
    
    if(write_cnt <= 0)
    {
        return NO_ERROR;
    }

    *pTWI_FIFO_CTL = 0;
    *pTWI_INT_STAT = *pTWI_INT_STAT;
    *pTWI_MASTER_STAT = BUFWRERR | BUFRDERR | LOSTARB | ANAK | DNAK | FAST;
    *pTWI_MASTER_ADDR = slave_addr;
    // Send first byte
    *pTWI_XMT_DATA8 = p_data[0];
    *pTWI_MASTER_CTL = TWI_COUNT(write_cnt) | MEN | (rstart ? RSTART : 0);
    ssync();

    for(l_idx = 1; l_idx < write_cnt; l_idx++)
    {
        while(((*pTWI_INT_STAT & MERR) == 0U) && (*pTWI_FIFO_STAT == XMTSTAT)) ssync();
        *pTWI_XMT_DATA8 = p_data[l_idx];
        ssync();
    }

    /* ]I܂őҋ@ */
    while((*pTWI_INT_STAT & MCOMP) == 0U) ssync();
    if((*pTWI_INT_STAT & MERR) == 0U)
    {
        return NO_ERROR;
    }
    else
    {
        return TWI_ERROR_NAK;
    }
}

DECL_INT_HANDLER(s_gptimer_isr)
{
    /* 荞݃Xe[^X̍XV */
    *pTIMER_STATUS = TIMIL0;
    ssync();
    
    /* JE^CNg(ݖgp) */
    sf_1ms_counter++;
}

